Request
Whenever the page sends a request for a network resource the following sequence of events are emitted by Page:
- page.on('request') emitted when the request is issued by the page.
- page.on('response') emitted when/if the response status and headers are received for the request.
- page.on('requestfinished') emitted when the response body is downloaded and the request is complete.
If request fails at some point, then instead of 'requestfinished' event (and possibly instead of 'response' event), the page.on('requestfailed') event is emitted.
HTTP Error responses, such as 404 or 503, are still successful responses from HTTP standpoint, so request will complete with 'requestfinished' event.
If request gets a 'redirect' response, the request is successfully finished with the requestfinished event, and a new request is issued to a redirected url.
Methods
allHeaders
Added in: v1.15An object with all the request HTTP headers associated with this request. The header names are lower-cased.
Usage
await request.allHeaders();
Returns
existingResponse
Added in: v1.59Returns the Response object if the response has already been received, null otherwise.
Unlike request.response(), this method does not wait for the response to arrive. It returns immediately with the response object if the response has been received, or null if the response has not been received yet.
Usage
request.existingResponse();
Returns
failure
Added before v1.9The method returns null unless this request has failed, as reported by requestfailed event.
Usage
Example of logging of all the failed requests:
page.on('requestfailed', request => {
console.log(request.url() + ' ' + request.failure().errorText);
});
Returns
frame
Added before v1.9Returns the Frame that initiated this request.
Usage
const frameUrl = request.frame().url();
Returns
Details
Note that in some cases the frame is not available, and this method will throw.
- When request originates in the Service Worker. You can use
request.serviceWorker()to check that. - When navigation request is issued before the corresponding frame is created. You can use request.isNavigationRequest() to check that.
Here is an example that handles all the cases:
if (request.serviceWorker())
console.log(`request ${request.url()} from a service worker`);
else if (request.isNavigationRequest())
console.log(`request ${request.url()} is a navigation request